require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xwineventlog',
  dscmeta_resource_friendly_name: 'xWinEventLog',
  dscmeta_resource_name: 'MSFT_xWinEventLog',
  dscmeta_module_name: 'xWinEventLog',
  dscmeta_module_version: '1.3.0.0',
  docs: 'The DSC xWinEventLog resource type.
         Automatically generated from version 1.3.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_securitydescriptor: {
      type: 'Optional[String]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_maximumsizeinbytes: {
      type: 'Optional[Integer[-9223372036854775808, 9223372036854775807]]',
      desc: 'sizethat the event log file is allowed to be When the file reaches this maximum size it is considered full',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'SInt64',
      mof_is_embedded: false,
    },
    dsc_logname: {
      type: 'String',
      desc: 'Name of the event log',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_logmode: {
      type: "Optional[Enum['AutoBackup', 'Circular', 'Retain']]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_logfilepath: {
      type: 'Optional[String]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_isenabled: {
      type: 'Optional[Boolean]',
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
  },
)
